datablock AudioProfile(HHFfireSound)
{
	filename = "./flammer_fire.wav";
	description = AudioClosestLooping3d;
	preload = true;
};

datablock ParticleData(HHFfireParticle)
{
	dragCoefficient      = 2.5;
	gravityCoefficient   = -0.1;	//-0.17
	inheritedVelFactor   = 1;
	constantAcceleration = 0;
	lifetimeMS           = 1250;
	lifetimeVarianceMS   = 750;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.1 0.1 1 1";
	colors[1]	= "1 0.5 0 0.5";
	colors[2]	= "1 0.25 0 0.25";
	colors[3]	= "1 1 1 0.05";
	sizes[0]	= 0.25;
	sizes[1]	= 0.5;
	sizes[2]	= 0.55;
	sizes[3]	= 0.7;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 0.8;
	times[3]	= 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HHFfireEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 20;	//15
   velocityVariance = 5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HHFfireParticle";

   uiName = "Hand Held Flamer Flame";
};

datablock ParticleData(HHFambientParticle)
{
	dragCoefficient      = 1.5;
	gravityCoefficient   = -0.25;
	inheritedVelFactor   = 0.5;
	windCoefficient      = 0.1;
	constantAcceleration = 0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.65 0 0.5";
	colors[1]     = "1 0 0 0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HHFambientEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HHFambientParticle";

   uiName = "Hand Held Flamer Ambient";
};

datablock ParticleData(HHFExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.2;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]		= "1 0.5 0 0.5";
	colors[1]		= "1 0.25 0 0.6";
	colors[2]		= "0.2 0.2 0.2 0.6";
	colors[3]		= "0 0 0 0";
	sizes[0]      = 0.4;
	sizes[1]      = 0.5;
	sizes[2]      = 0.7;
	sizes[3]      = 1;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 0.6;
	times[3]	= 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HHFExplosionEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 1.5;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HHFExplosionParticle";

   uiName = "Hand Held Flamer Burn";
};

datablock ExplosionData(HHFExplosion)
{
   lifeTimeMS = 300;

	particleEmitter = HHFexplosionEmitter;
	particleDensity = 8;
	particleRadius = 0.2;

//   emitter[0] = HHFexplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "1 1 1";
   camShakeAmp = "1.5 1 1";
   camShakeDuration = 0.2;
   camShakeRadius = 1;

	damageRadius = 1.6; 	//2
	radiusDamage = 1;		//7.5

//   lightStartRadius = 4;
//   lightEndRadius = 0;
//   lightStartColor = "1 0.6 0";
//   lightEndColor = "1 0.5 0";
};

AddDamageType("HHF",'<bitmap:add-ons/Weapon_HHF/CI_HHF> %1','%2 <bitmap:add-ons/Weapon_HHF/CI_HHF> %1',0.05,1);
datablock ProjectileData(HHFprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
//   projectileShapeName = "add-ons/Weapon_gun/bullet.dts";
   directDamage        = 5;	//3
   directDamageType    = $DamageType::HHF;
   radiusDamageType    = $DamageType::HHF;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 2;
   brickExplosionMaxVolumeFloating = 5;

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = HHFExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 70;
   bounceElasticity    = 0.01;
   bounceFriction      = 0.99;
   isBallistic         = false;
   gravityMod          = 0;

   hasLight    = true;
   lightRadius = 7;
   lightColor  = "1 0.6 0";
};

datablock ItemData(HHFItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./HHF.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "MAS HHF";
	iconName = "./icon_HHF";
	doColorShift = true;
	colorShiftColor = "1.000 1.000 1.000 1.000";

	image = HHFImage;
	canDrop = true;
};

datablock ShapeBaseImageData(HHFImage)
{
   shapeFile = HHFItem.shapeFile;
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;//"0.7 1.2 -0.5";
   rotation = "0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = HHFItem;
   ammo = " ";
   projectile = HHFprojectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = HHFItem.doColorShift;
   colorShiftColor = HHFItem.colorShiftColor;

   stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateWaitForTimeout[0]         = true;
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Fire";
   stateAllowImageChange[1]       = true;
   stateEmitter[1]                = HHFambientEmitter;
   stateEmitterTime[1]            = 10;
   stateEmitterNode[1]            = "muzzlePoint";

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Fire";
   stateTransitionOnTriggerUp[2]  = "Ready";
   stateTimeoutValue[2]           = 0.1;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = HHFfireEmitter;
   stateEmitterTime[2]            = 0.17;
   stateEmitterNode[2]            = "muzzlePoint";
   stateSound[2]                  = HHFfireSound;


};

function HHFImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
//	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));
//	%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%spread = 0.005;
	%shellcount = 3;	//1

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function HHFProjectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
   if(%col.getClassName() $="Player" || %col.getClassName() $="AIPlayer")
   {
      %col.burnPlayer(5);
   }
   parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
}
